/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
(function(){var e=["require","exports","vs/base/common/event","vs/base/common/lifecycle","vs/base/common/errors","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/functional","vs/base/common/platform","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/base/common/iterator","vs/base/common/async","vs/base/common/path","vs/base/common/uuid","vs/base/common/linkedList","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","net","os","vs/platform/driver/node/driver"],t=function(t){for(var s=[],n=0,i=t.length;n<i;n++)s[n]=e[t[n]];return s};define(e[5],t([0,1]),(function(e,t){"use strict";let s,n;Object.defineProperty(t,"__esModule",{value:!0}),t.hasBuffer="undefined"!=typeof Buffer;class i{constructor(e){this.buffer=e,this.byteLength=this.buffer.byteLength}static alloc(e){return t.hasBuffer?new i(Buffer.allocUnsafe(e)):new i(new Uint8Array(e))}static wrap(e){return t.hasBuffer&&!Buffer.isBuffer(e)&&(e=Buffer.from(e.buffer,e.byteOffset,e.byteLength)),new i(e)}
static fromString(e){return t.hasBuffer?new i(Buffer.from(e)):(s||(s=new TextEncoder),new i(s.encode(e)))}static concat(e,t){if(void 0===t){t=0;for(let s=0,n=e.length;s<n;s++)t+=e[s].byteLength}const s=i.alloc(t);let n=0;for(let t=0,i=e.length;t<i;t++){const i=e[t];s.set(i,n),n+=i.byteLength}return s}toString(){return t.hasBuffer?this.buffer.toString():(n||(n=new TextDecoder),n.decode(this.buffer))}slice(e,t){return new i(this.buffer.subarray(e,t))}set(e,t){this.buffer.set(e.buffer,t)}readUInt32BE(e){return r(this.buffer,e)}writeUInt32BE(e,t){o(this.buffer,e,t)}readUInt8(e){return function(e,t){return e[t]}(this.buffer,e)}writeUInt8(e,t){!function(e,t,s){e[s]=t}(this.buffer,e,t)}}function r(e,t){return e[t]*2**24+65536*e[t+1]+256*e[t+2]+e[t+3]}function o(e,t,s){e[s+3]=t,t>>>=8,e[s+2]=t,t>>>=8,e[s+1]=t,t>>>=8,e[s]=t}function a(){return new c}t.VSBuffer=i,t.readUInt32BE=r,t.writeUInt32BE=o,t.isVSBufferReadableStream=function(e){const t=e;return t&&[t.on,t.pause,t.resume,t.destroy].every(e=>"function"==typeof e)
},t.readableToBuffer=function(e){const t=[];let s;for(;s=e.read();)t.push(s);return i.concat(t)},t.bufferToReadable=function(e){let t=!1;return{read:()=>t?null:(t=!0,e)}},t.streamToBuffer=function(e){return new Promise((t,s)=>{const n=[];e.on("data",e=>n.push(e)),e.on("error",e=>s(e)),e.on("end",()=>t(i.concat(n)))})},t.bufferToStream=function(e){const t=a();return t.end(e),t},t.toVSBufferReadableStream=function(e){const t=a();return e.on("data",e=>t.write("string"==typeof e?i.fromString(e):i.wrap(e))),e.on("end",()=>t.end()),e.on("error",e=>t.error(e)),t},t.writeableBufferStream=a;class c{constructor(){this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]}}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(e){this.state.destroyed||(this.state.flowing?this.listeners.data.forEach(t=>t(e)):this.buffer.data.push(e))}
error(e){this.state.destroyed||(this.state.flowing?this.listeners.error.forEach(t=>t(e)):this.buffer.error.push(e))}end(e){this.state.destroyed||(e instanceof Error?this.error(e):e&&this.write(e),this.state.flowing?(this.listeners.end.forEach(e=>e()),this.destroy()):this.state.ended=!0)}on(e,t){if(!this.state.destroyed)switch(e){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors()}}flowData(){if(this.buffer.data.length>0){const e=i.concat(this.buffer.data);this.listeners.data.forEach(t=>t(e)),this.buffer.data.length=0}}flowErrors(){if(this.listeners.error.length>0){for(const e of this.buffer.error)this.listeners.error.forEach(t=>t(e));this.buffer.error.length=0}}flowEnd(){return!!this.state.ended&&(this.listeners.end.forEach(e=>e()),this.listeners.end.length>0)}destroy(){this.state.destroyed||(this.state.destroyed=!0,
this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0)}}})),define(e[4],t([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});class s{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(e){setTimeout(()=>{if(e.stack)throw new Error(e.message+"\n\n"+e.stack);throw e},0)}}addListener(e){return this.listeners.push(e),()=>{this._removeListener(e)}}emit(e){this.listeners.forEach(t=>{t(e)})}_removeListener(e){this.listeners.splice(this.listeners.indexOf(e),1)}setUnexpectedErrorHandler(e){this.unexpectedErrorHandler=e}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(e){this.unexpectedErrorHandler(e),this.emit(e)}onUnexpectedExternalError(e){this.unexpectedErrorHandler(e)}}t.ErrorHandler=s,t.errorHandler=new s,t.setUnexpectedErrorHandler=function(e){t.errorHandler.setUnexpectedErrorHandler(e)},t.onUnexpectedError=function(e){
i(e)||t.errorHandler.onUnexpectedError(e)},t.onUnexpectedExternalError=function(e){i(e)||t.errorHandler.onUnexpectedExternalError(e)},t.transformErrorForSerialization=function(e){if(e instanceof Error){let{name:t,message:s}=e;return{$isError:!0,name:t,message:s,stack:e.stacktrace||e.stack}}return e};const n="Canceled";function i(e){return e instanceof Error&&e.name===n&&e.message===n}t.isPromiseCanceledError=i,t.canceled=function(){const e=new Error(n);return e.name=e.message,e},t.illegalArgument=function(e){return e?new Error(`Illegal argument: ${e}`):new Error("Illegal argument")},t.illegalState=function(e){return e?new Error(`Illegal state: ${e}`):new Error("Illegal state")},t.readonly=function(e){return e?new Error(`readonly property '${e} cannot be changed'`):new Error("readonly property cannot be changed")},t.disposed=function(e){const t=new Error(`${e} has been disposed`);return t.name="DISPOSED",t},t.getErrorMessage=function(e){
return e?e.message?e.message:e.stack?e.stack.split("\n")[0]:String(e):"Error"};t.NotImplementedError=class extends Error{constructor(e){super("NotImplemented"),e&&(this.message=e)}}})),define(e[7],t([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=function(e){const t=this;let s,n=!1;return function(){return n?s:(n=!0,s=e.apply(t,arguments))}}})),define(e[11],t([0,1]),(function(e,t){"use strict";var s;Object.defineProperty(t,"__esModule",{value:!0}),t.FIN={done:!0,value:void 0},function(e){const s={next:()=>t.FIN};e.empty=function(){return s},e.single=function(e){let s=!1;return{next:()=>s?t.FIN:(s=!0,{done:!1,value:e})}},e.fromArray=function(e,s=0,n=e.length){return{next:()=>s>=n?t.FIN:{done:!1,value:e[s++]}}},e.fromNativeIterator=function(e){return{next(){const s=e.next();return s.done?t.FIN:{done:!1,value:s.value}}}},e.from=function(t){return t?Array.isArray(t)?e.fromArray(t):t:e.empty()},e.map=function(e,s){return{next(){const n=e.next();return n.done?t.FIN:{
done:!1,value:s(n.value)}}}},e.filter=function(e,s){return{next(){for(;;){const n=e.next();if(n.done)return t.FIN;if(s(n.value))return{done:!1,value:n.value}}}}},e.forEach=function(e,t){for(let s=e.next();!s.done;s=e.next())t(s.value)},e.collect=function(e,t=Number.POSITIVE_INFINITY){const s=[];if(0===t)return s;let n=0;for(let i=e.next();!i.done&&(s.push(i.value),!(++n>=t));i=e.next());return s},e.concat=function(...e){let s=0;return{next(){if(s>=e.length)return t.FIN;const n=e[s].next();return n.done?(s++,this.next()):n}}}}(s=t.Iterator||(t.Iterator={})),t.getSequenceIterator=function(e){return Array.isArray(e)?s.fromArray(e):e};class n{constructor(e,t=0,s=e.length,n=t-1){this.items=e,this.start=t,this.end=s,this.index=n}first(){return this.index=this.start,this.current()}next(){return this.index=Math.min(this.index+1,this.end),this.current()}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}}t.ArrayIterator=n;t.ArrayNavigator=class extends n{
constructor(e,t=0,s=e.length,n=t-1){super(e,t,s,n)}current(){return super.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}parent(){return null}};class i{constructor(e,t){this.iterator=e,this.fn=t}next(){return this.fn(this.iterator.next())}}t.MappedIterator=i;t.MappedNavigator=class extends i{constructor(e,t){super(e,t),this.navigator=e}current(){return this.fn(this.navigator.current())}previous(){return this.fn(this.navigator.previous())}parent(){return this.fn(this.navigator.parent())}first(){return this.fn(this.navigator.first())}last(){return this.fn(this.navigator.last())}next(){return this.fn(this.navigator.next())}}})),define(e[3],t([0,1,7]),(function(e,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});const n=!1,i="__is_disposable_tracked__";function r(e){if(n&&e&&e!==h.None)try{e[i]=!0}catch(e){}}function o(e){if(!n)return e
;const t=new Error("Potentially leaked disposable").stack;return setTimeout(()=>{e[i]||console.log(t)},3e3),e}function a(e){return Array.isArray(e)?(e.forEach(e=>{e&&(r(e),e.dispose())}),[]):e?(r(e),e.dispose(),e):void 0}t.isDisposable=function(e){return"function"==typeof e.dispose&&0===e.dispose.length},t.dispose=a,t.combinedDisposable=function(...e){return e.forEach(r),o({dispose:()=>a(e)})},t.toDisposable=function(e){const t=o({dispose:()=>{r(t),e()}});return t};class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(r(this),this._isDisposed=!0,this.clear())}clear(){this._toDispose.forEach(e=>e.dispose()),this._toDispose.clear()}add(e){if(!e)return e;if(e===this)throw new Error("Cannot register a disposable on itself!");return r(e),this._isDisposed?console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(e),e}}t.DisposableStore=c;class h{constructor(){
this._store=new c,o(this)}dispose(){r(this),this._store.dispose()}_register(e){if(e===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(e)}}t.Disposable=h,h.None=Object.freeze({dispose(){}});t.MutableDisposable=class{constructor(){this._isDisposed=!1,o(this)}get value(){return this._isDisposed?void 0:this._value}set value(e){this._isDisposed||e===this._value||(this._value&&this._value.dispose(),e&&r(e),this._value=e)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,r(this),this._value&&this._value.dispose(),this._value=void 0}};t.UnownedDisposable=class extends h{constructor(e){super(),this._hasBeenAcquired=!1,this._value=e}acquire(){if(this._hasBeenAcquired)throw new Error("This disposable has already been acquired");this._hasBeenAcquired=!0;const e=this._value;return this._value=void 0,e}dispose(){super.dispose(),this._hasBeenAcquired||(this._hasBeenAcquired=!0,this._value.dispose(),this._value=void 0)}};t.ReferenceCollection=class{constructor(){
this.references=new Map}acquire(e){let t=this.references.get(e);t||(t={counter:0,object:this.createReferencedObject(e)},this.references.set(e,t));const{object:n}=t,i=s.once(()=>{0==--t.counter&&(this.destroyReferencedObject(e,t.object),this.references.delete(e))});return t.counter++,{object:n,dispose:i}}};t.ImmortalReference=class{constructor(e){this.object=e}dispose(){}}})),define(e[15],t([0,1,11]),(function(e,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});class n{constructor(e){this.element=e,this.next=n.Undefined,this.prev=n.Undefined}}n.Undefined=new n(void 0);t.LinkedList=class{constructor(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===n.Undefined}clear(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}unshift(e){return this._insert(e,!1)}push(e){return this._insert(e,!0)}_insert(e,t){const s=new n(e);if(this._first===n.Undefined)this._first=s,this._last=s;else if(t){const e=this._last;this._last=s,
s.prev=e,e.next=s}else{const e=this._first;this._first=s,s.next=e,e.prev=s}this._size+=1;let i=!1;return()=>{i||(i=!0,this._remove(s))}}shift(){if(this._first!==n.Undefined){const e=this._first.element;return this._remove(this._first),e}}pop(){if(this._last!==n.Undefined){const e=this._last.element;return this._remove(this._last),e}}_remove(e){if(e.prev!==n.Undefined&&e.next!==n.Undefined){const t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===n.Undefined&&e.next===n.Undefined?(this._first=n.Undefined,this._last=n.Undefined):e.next===n.Undefined?(this._last=this._last.prev,this._last.next=n.Undefined):e.prev===n.Undefined&&(this._first=this._first.next,this._first.prev=n.Undefined);this._size-=1}iterator(){let e,t=this._first;return{next:()=>t===n.Undefined?s.FIN:(e?e.value=t.element:e={done:!1,value:t.element},t=t.next,e)}}toArray(){const e=[];for(let t=this._first;t!==n.Undefined;t=t.next)e.push(t.element);return e}}})),define(e[2],t([0,1,4,7,3,15]),(function(e,t,s,n,i,r){"use strict";var o
;Object.defineProperty(t,"__esModule",{value:!0}),function(e){function t(e){return(t,s=null,n)=>{let i,r=!1;return i=e(e=>{if(!r)return i?i.dispose():r=!0,t.call(s,e)},null,n),r&&i.dispose(),i}}function s(e,t){return a((s,n=null,i)=>e(e=>s.call(n,t(e)),null,i))}function n(e,t){return a((s,n=null,i)=>e(e=>{t(e),s.call(n,e)},null,i))}function r(e,t){return a((s,n=null,i)=>e(e=>t(e)&&s.call(n,e),null,i))}function o(e,t,n){let i=n;return s(e,e=>i=t(i,e))}function a(e){let t;const s=new h({onFirstListenerAdd(){t=e(s.fire,s)},onLastListenerRemove(){t.dispose()}});return s.event}function c(e,t,s=100,n=!1,i){let r,o=void 0,a=void 0,c=0;const l=new h({leakWarningThreshold:i,onFirstListenerAdd(){r=e(e=>{c++,o=t(o,e),n&&!a&&l.fire(o),clearTimeout(a),a=setTimeout(()=>{const e=o;o=void 0,a=void 0,(!n||c>1)&&l.fire(e),c=0},s)})},onLastListenerRemove(){r.dispose()}});return l.event}function l(e){let t,s=!0;return r(e,e=>{const n=s||e!==t;return s=!1,t=e,n})}e.None=()=>i.Disposable.None,e.once=t,e.map=s,e.forEach=n,
e.filter=r,e.signal=function(e){return e},e.any=function(...e){return(t,s=null,n)=>i.combinedDisposable(...e.map(e=>e(e=>t.call(s,e),null,n)))},e.reduce=o,e.snapshot=a,e.debounce=c,e.stopwatch=function(e){const n=(new Date).getTime();return s(t(e),e=>(new Date).getTime()-n)},e.latch=l,e.buffer=function(e,t=!1,s=[]){let n=s.slice(),i=e(e=>{n?n.push(e):o.fire(e)});const r=()=>{n&&n.forEach(e=>o.fire(e)),n=null},o=new h({onFirstListenerAdd(){i||(i=e(e=>o.fire(e)))},onFirstListenerDidAdd(){n&&(t?setTimeout(r):r())},onLastListenerRemove(){i&&i.dispose(),i=null}});return o.event};class u{constructor(e){this.event=e}map(e){return new u(s(this.event,e))}forEach(e){return new u(n(this.event,e))}filter(e){return new u(r(this.event,e))}reduce(e,t){return new u(o(this.event,e,t))}latch(){return new u(l(this.event))}debounce(e,t=100,s=!1,n){return new u(c(this.event,e,t,s,n))}on(e,t,s){return this.event(e,t,s)}once(e,s,n){return t(this.event)(e,s,n)}}e.chain=function(e){return new u(e)},
e.fromNodeEventEmitter=function(e,t,s=(e=>e)){const n=(...e)=>i.fire(s(...e)),i=new h({onFirstListenerAdd:()=>e.on(t,n),onLastListenerRemove:()=>e.removeListener(t,n)});return i.event},e.fromDOMEventEmitter=function(e,t,s=(e=>e)){const n=(...e)=>i.fire(s(...e)),i=new h({onFirstListenerAdd:()=>e.addEventListener(t,n),onLastListenerRemove:()=>e.removeEventListener(t,n)});return i.event},e.fromPromise=function(e){const t=new h;let s=!1;return e.then(void 0,()=>null).then(()=>{s?t.fire(void 0):setTimeout(()=>t.fire(void 0),0)}),s=!0,t.event},e.toPromise=function(e){return new Promise(s=>t(e)(s))}}(o=t.Event||(t.Event={}));let a=-1;t.setGlobalLeakWarningThreshold=function(e){const t=a;return a=e,{dispose(){a=t}}};class c{constructor(e,t=Math.random().toString(18).slice(2,5)){this.customThreshold=e,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(e){let t=a;if("number"==typeof this.customThreshold&&(t=this.customThreshold),t<=0||e<t)return;this._stacks||(this._stacks=new Map)
;const s=(new Error).stack.split("\n").slice(3).join("\n"),n=this._stacks.get(s)||0;if(this._stacks.set(s,n+1),this._warnCountdown-=1,this._warnCountdown<=0){let s;this._warnCountdown=.5*t;let n=0;this._stacks.forEach((e,t)=>{(!s||n<e)&&(s=t,n=e)}),console.warn(`[${this.name}] potential listener LEAK detected, having ${e} listeners already. MOST frequent listener (${n}):`),console.warn(s)}return()=>{const e=this._stacks.get(s)||0;this._stacks.set(s,e-1)}}}class h{constructor(e){this._disposed=!1,this._options=e,this._leakageMon=a>0?new c(this._options&&this._options.leakWarningThreshold):void 0}get event(){return this._event||(this._event=(e,t,s)=>{this._listeners||(this._listeners=new r.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(t?[e,t]:e);let a,c;return n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),
this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,e,t),this._leakageMon&&(a=this._leakageMon.check(this._listeners.size)),c={dispose:()=>{if(a&&a(),c.dispose=h._noop,!this._disposed&&(o(),this._options&&this._options.onLastListenerRemove)){this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)}}},s instanceof i.DisposableStore?s.add(c):Array.isArray(s)&&s.push(c),c}),this._event}fire(e){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new r.LinkedList);for(let t=this._listeners.iterator(),s=t.next();!s.done;s=t.next())this._deliveryQueue.push([s.value,e]);for(;this._deliveryQueue.size>0;){const[e,t]=this._deliveryQueue.shift();try{"function"==typeof e?e.call(void 0,t):e[0].call(e[1],t)}catch(e){s.onUnexpectedError(e)}}}}dispose(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),this._disposed=!0}}t.Emitter=h,h._noop=function(){}
;t.PauseableEmitter=class extends h{constructor(e){super(e),this._isPaused=0,this._eventQueue=new r.LinkedList,this._mergeFn=e&&e.merge}pause(){this._isPaused++}resume(){if(0!==this._isPaused&&0==--this._isPaused)if(this._mergeFn){const e=this._eventQueue.toArray();this._eventQueue.clear(),super.fire(this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)super.fire(this._eventQueue.shift())}fire(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):super.fire(e))}};t.AsyncEmitter=class extends h{async fireAsync(e){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=[]);for(let t=this._listeners.iterator(),s=t.next();!s.done;s=t.next()){const t=[];this._asyncDeliveryQueue.push([s.value,e(t,"function"==typeof s.value?s.value:s.value[0]),t])}for(;this._asyncDeliveryQueue.length>0;){const[e,t,n]=this._asyncDeliveryQueue.shift();try{"function"==typeof e?e.call(void 0,t):e[0].call(e[1],t)}catch(e){s.onUnexpectedError(e);continue}Object.freeze(n),await Promise.all(n)}}
}};t.EventMultiplexer=class{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(e){const t={event:e,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);return i.toDisposable(n.once(()=>{this.hasListeners&&this.unhook(t);const e=this.events.indexOf(t);this.events.splice(e,1)}))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(e=>this.hook(e))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(e=>this.unhook(e))}hook(e){e.listener=e.event(e=>this.emitter.fire(e))}unhook(e){e.listener&&e.listener.dispose(),e.listener=null}dispose(){this.emitter.dispose()}};t.EventBufferer=class{constructor(){this.buffers=[]}wrapEvent(e){return(t,s,n)=>e(e=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>t.call(s,e)):t.call(s,e)},void 0,n)}bufferEvents(e){const t=[];this.buffers.push(t);const s=e()
;return this.buffers.pop(),t.forEach(e=>e()),s}};t.Relay=class{constructor(){this.listening=!1,this.inputEvent=o.None,this.inputEventListener=i.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(e){this.inputEvent=e,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=e(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}})),define(e[6],t([0,1,2]),(function(e,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});const n=Object.freeze((function(e,t){const s=setTimeout(e.bind(t),0);return{dispose(){clearTimeout(s)}}}));var i;!function(e){e.isCancellationToken=function(t){
return t===e.None||t===e.Cancelled||(t instanceof r||!(!t||"object"!=typeof t)&&("boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested))},e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:s.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})}(i=t.CancellationToken||(t.CancellationToken={}));class r{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new s.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}t.CancellationTokenSource=class{constructor(e){this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}get token(){
return this._token||(this._token=new r),this._token}cancel(){this._token?this._token instanceof r&&this._token.cancel():this._token=i.Cancelled}dispose(){this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof r&&this._token.dispose():this._token=i.None}}})),define(e[12],t([0,1,6,4,2,3]),(function(e,t,s,n,i,r){"use strict";function o(e){return e&&"function"==typeof e.then}function a(e){const t=new s.CancellationTokenSource,i=e(t.token),r=new Promise((e,s)=>{t.token.onCancellationRequested(()=>{s(n.canceled())}),Promise.resolve(i).then(s=>{t.dispose(),e(s)},e=>{t.dispose(),s(e)})});return new class{cancel(){t.cancel()}then(e,t){return r.then(e,t)}catch(e){return this.then(void 0,e)}finally(e){return r.finally(e)}}}Object.defineProperty(t,"__esModule",{value:!0}),t.isThenable=o,t.createCancelablePromise=a,t.raceCancellation=function(e,t,s){return Promise.race([e,new Promise(e=>t.onCancellationRequested(()=>e(s)))])},t.asPromise=function(e){return new Promise((t,s)=>{const n=e()
;o(n)?n.then(t,s):t(n)})};class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(e){if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){const e=()=>{this.queuedPromise=null;const e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,e};this.queuedPromise=new Promise(t=>{this.activePromise.then(e,e).then(t)})}return new Promise((e,t)=>{this.queuedPromise.then(e,t)})}return this.activePromise=e(),new Promise((e,t)=>{this.activePromise.then(t=>{this.activePromise=null,e(t)},e=>{this.activePromise=null,t(e)})})}}t.Throttler=c;t.Sequencer=class{constructor(){this.current=Promise.resolve(null)}queue(e){return this.current=this.current.then(()=>e())}};class h{constructor(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.task=null}trigger(e,t=this.defaultDelay){return this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((e,t)=>{
this.doResolve=e,this.doReject=t}).then(()=>{this.completionPromise=null,this.doResolve=null;const e=this.task;return this.task=null,e()})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve(null)},t),this.completionPromise}isTriggered(){return null!==this.timeout}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject(n.canceled()),this.completionPromise=null)}cancelTimeout(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}t.Delayer=h;t.ThrottledDelayer=class{constructor(e){this.delayer=new h(e),this.throttler=new c}trigger(e,t){return this.delayer.trigger(()=>this.throttler.queue(e),t)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}};function l(e,t){return t?new Promise((s,i)=>{const r=setTimeout(s,e);t.onCancellationRequested(()=>{clearTimeout(r),i(n.canceled())})}):a(t=>l(e,t))}t.Barrier=class{constructor(){this._isOpen=!1,this._promise=new Promise((e,t)=>{
this._completePromise=e})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}},t.timeout=l,t.disposableTimeout=function(e,t=0){const s=setTimeout(e,t);return r.toDisposable(()=>clearTimeout(s))},t.ignoreErrors=function(e){return e.then(void 0,e=>void 0)},t.sequence=function(e){const t=[];let s=0;const n=e.length;return Promise.resolve(null).then((function i(r){null!=r&&t.push(r);const o=s<n?e[s++]():null;return o?o.then(i):Promise.resolve(t)}))},t.first=function(e,t=(e=>!!e),s=null){let n=0;const i=e.length,r=()=>{if(n>=i)return Promise.resolve(s);const o=e[n++];return Promise.resolve(o()).then(e=>t(e)?Promise.resolve(e):r())};return r()};class u{constructor(e){this._size=0,this.maxDegreeOfParalellism=e,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new i.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(e){return this._size++,new Promise((t,s)=>{this.outstandingPromises.push({factory:e,c:t,e:s
}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const e=this.outstandingPromises.shift();this.runningPromises++;const t=e.factory();t.then(e.c,e.e),t.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}t.Limiter=u;class d extends u{constructor(){super(1)}}t.Queue=d;t.ResourceQueue=class{constructor(){this.queues=new Map}queueFor(e){const t=e.toString();if(!this.queues.has(t)){const e=new d;e.onFinished(()=>{e.dispose(),this.queues.delete(t)}),this.queues.set(t,e)}return this.queues.get(t)}};t.TimeoutTimer=class{constructor(e,t){this._token=-1,"function"==typeof e&&"number"==typeof t&&this.setIfNotSet(e,t)}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setTimeout(()=>{this._token=-1,e()},t)}
setIfNotSet(e,t){-1===this._token&&(this._token=setTimeout(()=>{this._token=-1,e()},t))}};t.IntervalTimer=class{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearInterval(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setInterval(()=>{e()},t)}};class f{constructor(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(e=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,e)}isScheduled(){return-1!==this.timeoutToken}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}t.RunOnceScheduler=f;t.RunOnceWorker=class extends f{constructor(e,t){super(e,t),this.units=[]}work(e){this.units.push(e),this.isScheduled()||this.schedule()}doRun(){const e=this.units;this.units=[],this.runner&&this.runner(e)}dispose(){
this.units=[],super.dispose()}},function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){const e=Object.freeze({didTimeout:!0,timeRemaining:()=>15});t.runWhenIdle=t=>{const s=setTimeout(()=>t(e));let n=!1;return{dispose(){n||(n=!0,clearTimeout(s))}}}}else t.runWhenIdle=(e,t)=>{const s=requestIdleCallback(e,"number"==typeof t?{timeout:t}:void 0);let n=!1;return{dispose(){n||(n=!0,cancelIdleCallback(s))}}}}();t.IdleValue=class{constructor(e){this._didRun=!1,this._executor=()=>{try{this._value=e()}catch(e){this._error=e}finally{this._didRun=!0}},this._handle=t.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}getValue(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}},t.retry=async function(e,t,s){let n;for(let i=0;i<s;i++)try{return await e()}catch(e){n=e,await l(t)}return Promise.reject(n)}})),define(e[8],t([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})
;let s=!1,n=!1,i=!1,r=!1,o=!1,a=void 0,c="en",h=void 0,l=void 0;const u="undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.electron&&"renderer"===process.type;if("object"!=typeof navigator||u){if("object"==typeof process){s="win32"===process.platform,n="darwin"===process.platform,i="linux"===process.platform,a="en",c="en";const e=process.env.VSCODE_NLS_CONFIG;if(e)try{const t=JSON.parse(e),s=t.availableLanguages["*"];a=t.locale,c=s||"en",h=t._translationsConfigFile}catch(e){}r=!0}}else l=navigator.userAgent,s=l.indexOf("Windows")>=0,n=l.indexOf("Macintosh")>=0,i=l.indexOf("Linux")>=0,o=!0,c=a=navigator.language;!function(e){e[e.Web=0]="Web",e[e.Mac=1]="Mac",e[e.Linux=2]="Linux",e[e.Windows=3]="Windows"}(t.Platform||(t.Platform={})),t.PlatformToString=function(e){switch(e){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}};let d=0;n?d=1:s?d=3:i&&(d=2),t.isWindows=s,t.isMacintosh=n,t.isLinux=i,t.isNative=r,t.isWeb=o,t.platform=d,t.userAgent=l,
t.isRootUser=function(){return r&&!s&&0===process.getuid()},t.language=c,function(e){e.value=function(){return t.language},e.isDefaultVariant=function(){return 2===t.language.length?"en"===t.language:t.language.length>=3&&("e"===t.language[0]&&"n"===t.language[1]&&"-"===t.language[2])},e.isDefault=function(){return"en"===t.language}}(t.Language||(t.Language={})),t.locale=a,t.translationsConfigFile=h;const f="object"==typeof self?self:"object"==typeof global?global:{};t.globals=f,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if("undefined"!=typeof process&&"function"==typeof process.nextTick)return process.nextTick.bind(process);const e=Promise.resolve();return t=>e.then(t)}(),function(e){e[e.Windows=1]="Windows",e[e.Macintosh=2]="Macintosh",e[e.Linux=3]="Linux"}(t.OperatingSystem||(t.OperatingSystem={})),t.OS=n?2:s?1:3})),define(e[9],t([0,1,8]),(function(e,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0})
;const n="undefined"==typeof process?{cwd:()=>"/",env:Object.create(null),get platform(){return s.isWindows?"win32":s.isMacintosh?"darwin":"linux"},nextTick:e=>s.setImmediate(e)}:process;t.cwd=n.cwd,t.env=n.env,t.platform=n.platform,t.nextTick=n.nextTick})),define(e[13],t([0,1,9]),(function(e,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});const n=65,i=97,r=90,o=122,a=46,c=47,h=92;class l extends Error{constructor(e,t,s){let n;"string"==typeof t&&0===t.indexOf("not ")?(n="must not be",t=t.replace(/^not /,"")):n="must be";const i=-1!==e.indexOf(".")?"property":"argument";let r=`The "${e}" ${i} ${n} of type ${t}`;super(r+=`. Received type ${typeof s}`),this.code="ERR_INVALID_ARG_TYPE"}}function u(e,t){if("string"!=typeof e)throw new l(t,"string",e)}function d(e){return e===c||e===h}function f(e){return e===c}function p(e){return e>=n&&e<=r||e>=i&&e<=o}function m(e,t,s,n){let i,r="",o=0,h=-1,l=0;for(let u=0;u<=e.length;++u){if(u<e.length)i=e.charCodeAt(u);else{if(n(i))break;i=c}if(n(i)){
if(h===u-1||1===l);else if(h!==u-1&&2===l){if(r.length<2||2!==o||r.charCodeAt(r.length-1)!==a||r.charCodeAt(r.length-2)!==a){if(r.length>2){const e=r.lastIndexOf(s);-1===e?(r="",o=0):o=(r=r.slice(0,e)).length-1-r.lastIndexOf(s),h=u,l=0;continue}if(2===r.length||1===r.length){r="",o=0,h=u,l=0;continue}}t&&(r.length>0?r+=`${s}..`:r="..",o=2)}else r.length>0?r+=s+e.slice(h+1,u):r=e.slice(h+1,u),o=u-h-1;h=u,l=0}else i===a&&-1!==l?++l:l=-1}return r}function g(e,t){const s=t.dir||t.root,n=t.base||(t.name||"")+(t.ext||"");return s?s===t.root?s+n:s+e+n:n}t.win32={resolve(...e){let t="",n="",i=!1;for(let r=e.length-1;r>=-1;r--){let o;if(r>=0?o=e[r]:t?void 0!==(o=s.env["="+t]||s.cwd())&&o.slice(0,3).toLowerCase()===t.toLowerCase()+"\\"||(o=t+"\\"):o=s.cwd(),u(o,"path"),0===o.length)continue;const a=o.length;let c=0,h="",l=!1;const f=o.charCodeAt(0);if(a>1)if(d(f))if(l=!0,d(o.charCodeAt(1))){let e=2,t=e;for(;e<a&&!d(o.charCodeAt(e));++e);if(e<a&&e!==t){const s=o.slice(t,e);for(t=e;e<a&&d(o.charCodeAt(e));++e);
if(e<a&&e!==t){for(t=e;e<a&&!d(o.charCodeAt(e));++e);e===a?(h="\\\\"+s+"\\"+o.slice(t),c=e):e!==t&&(h="\\\\"+s+"\\"+o.slice(t,e),c=e)}}}else c=1;else p(f)&&58===o.charCodeAt(1)&&(h=o.slice(0,2),c=2,a>2&&d(o.charCodeAt(2))&&(l=!0,c=3));else d(f)&&(c=1,l=!0);if(!(h.length>0&&t.length>0&&h.toLowerCase()!==t.toLowerCase())&&(0===t.length&&h.length>0&&(t=h),i||(n=o.slice(c)+"\\"+n,i=l),t.length>0&&i))break}return t+(i?"\\":"")+(n=m(n,!i,"\\",d))||"."},normalize(e){u(e,"path");const t=e.length;if(0===t)return".";let s,n=0,i=!1;const r=e.charCodeAt(0);if(t>1)if(d(r))if(i=!0,d(e.charCodeAt(1))){let i=2,r=i;for(;i<t&&!d(e.charCodeAt(i));++i);if(i<t&&i!==r){const o=e.slice(r,i);for(r=i;i<t&&d(e.charCodeAt(i));++i);if(i<t&&i!==r){for(r=i;i<t&&!d(e.charCodeAt(i));++i);if(i===t)return"\\\\"+o+"\\"+e.slice(r)+"\\";i!==r&&(s="\\\\"+o+"\\"+e.slice(r,i),n=i)}}}else n=1;else p(r)&&58===e.charCodeAt(1)&&(s=e.slice(0,2),n=2,t>2&&d(e.charCodeAt(2))&&(i=!0,n=3));else if(d(r))return"\\";let o
;return 0!==(o=n<t?m(e.slice(n),!i,"\\",d):"").length||i||(o="."),o.length>0&&d(e.charCodeAt(t-1))&&(o+="\\"),void 0===s?i?o.length>0?"\\"+o:"\\":o.length>0?o:"":i?o.length>0?s+"\\"+o:s+"\\":o.length>0?s+o:s},isAbsolute(e){u(e,"path");const t=e.length;if(0===t)return!1;const s=e.charCodeAt(0);return!!d(s)||!!(p(s)&&t>2&&58===e.charCodeAt(1)&&d(e.charCodeAt(2)))},join(...e){if(0===e.length)return".";let s,n;for(let t=0;t<e.length;++t){const i=e[t];u(i,"path"),i.length>0&&(void 0===s?s=n=i:s+="\\"+i)}if(void 0===s)return".";let i=!0,r=0;if("string"==typeof n&&d(n.charCodeAt(0))){++r;const e=n.length;e>1&&d(n.charCodeAt(1))&&(++r,e>2&&(d(n.charCodeAt(2))?++r:i=!1))}if(i){for(;r<s.length&&d(s.charCodeAt(r));++r);r>=2&&(s="\\"+s.slice(r))}return t.win32.normalize(s)},relative(e,s){if(u(e,"from"),u(s,"to"),e===s)return"";const n=t.win32.resolve(e),i=t.win32.resolve(s);if(n===i)return"";if((e=n.toLowerCase())===(s=i.toLowerCase()))return"";let r=0;for(;r<e.length&&e.charCodeAt(r)===h;++r);let o=e.length
;for(;o-1>r&&e.charCodeAt(o-1)===h;--o);const a=o-r;let c=0;for(;c<s.length&&s.charCodeAt(c)===h;++c);let l=s.length;for(;l-1>c&&s.charCodeAt(l-1)===h;--l);const d=l-c,f=a<d?a:d;let p=-1,m=0;for(;m<=f;++m){if(m===f){if(d>f){if(s.charCodeAt(c+m)===h)return i.slice(c+m+1);if(2===m)return i.slice(c+m)}a>f&&(e.charCodeAt(r+m)===h?p=m:2===m&&(p=3));break}const t=e.charCodeAt(r+m);if(t!==s.charCodeAt(c+m))break;t===h&&(p=m)}if(m!==f&&-1===p)return i;let g="";for(-1===p&&(p=0),m=r+p+1;m<=o;++m)m!==o&&e.charCodeAt(m)!==h||(0===g.length?g+="..":g+="\\..");return g.length>0?g+i.slice(c+p,l):(c+=p,i.charCodeAt(c)===h&&++c,i.slice(c,l))},toNamespacedPath(e){if("string"!=typeof e)return e;if(0===e.length)return"";const s=t.win32.resolve(e);if(s.length>=3)if(s.charCodeAt(0)===h){if(s.charCodeAt(1)===h){const e=s.charCodeAt(2);if(63!==e&&e!==a)return"\\\\?\\UNC\\"+s.slice(2)}}else if(p(s.charCodeAt(0))&&58===s.charCodeAt(1)&&s.charCodeAt(2)===h)return"\\\\?\\"+s;return e},dirname(e){u(e,"path");const t=e.length
;if(0===t)return".";let s=-1,n=-1,i=!0,r=0;const o=e.charCodeAt(0);if(t>1)if(d(o)){if(s=r=1,d(e.charCodeAt(1))){let n=2,i=n;for(;n<t&&!d(e.charCodeAt(n));++n);if(n<t&&n!==i){for(i=n;n<t&&d(e.charCodeAt(n));++n);if(n<t&&n!==i){for(i=n;n<t&&!d(e.charCodeAt(n));++n);if(n===t)return e;n!==i&&(s=r=n+1)}}}}else p(o)&&58===e.charCodeAt(1)&&(s=r=2,t>2&&d(e.charCodeAt(2))&&(s=r=3));else if(d(o))return e;for(let s=t-1;s>=r;--s)if(d(e.charCodeAt(s))){if(!i){n=s;break}}else i=!1;if(-1===n){if(-1===s)return".";n=s}return e.slice(0,n)},basename(e,t){void 0!==t&&u(t,"ext"),u(e,"path");let s,n=0,i=-1,r=!0;if(e.length>=2){p(e.charCodeAt(0))&&58===e.charCodeAt(1)&&(n=2)}if(void 0!==t&&t.length>0&&t.length<=e.length){if(t.length===e.length&&t===e)return"";let o=t.length-1,a=-1;for(s=e.length-1;s>=n;--s){const c=e.charCodeAt(s);if(d(c)){if(!r){n=s+1;break}}else-1===a&&(r=!1,a=s+1),o>=0&&(c===t.charCodeAt(o)?-1==--o&&(i=s):(o=-1,i=a))}return n===i?i=a:-1===i&&(i=e.length),e.slice(n,i)}
for(s=e.length-1;s>=n;--s)if(d(e.charCodeAt(s))){if(!r){n=s+1;break}}else-1===i&&(r=!1,i=s+1);return-1===i?"":e.slice(n,i)},extname(e){u(e,"path");let t=0,s=-1,n=0,i=-1,r=!0,o=0;e.length>=2&&58===e.charCodeAt(1)&&p(e.charCodeAt(0))&&(t=n=2);for(let c=e.length-1;c>=t;--c){const t=e.charCodeAt(c);if(d(t)){if(!r){n=c+1;break}}else-1===i&&(r=!1,i=c+1),t===a?-1===s?s=c:1!==o&&(o=1):-1!==s&&(o=-1)}return-1===s||-1===i||0===o||1===o&&s===i-1&&s===n+1?"":e.slice(s,i)},format(e){if(null===e||"object"!=typeof e)throw new l("pathObject","Object",e);return g("\\",e)},parse(e){u(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const s=e.length;let n=0,i=e.charCodeAt(0);if(s>1){if(d(i)){if(n=1,d(e.charCodeAt(1))){let t=2,i=t;for(;t<s&&!d(e.charCodeAt(t));++t);if(t<s&&t!==i){for(i=t;t<s&&d(e.charCodeAt(t));++t);if(t<s&&t!==i){for(i=t;t<s&&!d(e.charCodeAt(t));++t);t===s?n=t:t!==i&&(n=t+1)}}}}else if(p(i)&&58===e.charCodeAt(1)){if(n=2,!(s>2))return t.root=t.dir=e,t;if(d(e.charCodeAt(2))){
if(3===s)return t.root=t.dir=e,t;n=3}}}else if(d(i))return t.root=t.dir=e,t;n>0&&(t.root=e.slice(0,n));let r=-1,o=n,c=-1,h=!0,l=e.length-1,f=0;for(;l>=n;--l)if(d(i=e.charCodeAt(l))){if(!h){o=l+1;break}}else-1===c&&(h=!1,c=l+1),i===a?-1===r?r=l:1!==f&&(f=1):-1!==r&&(f=-1);return-1===r||-1===c||0===f||1===f&&r===c-1&&r===o+1?-1!==c&&(t.base=t.name=e.slice(o,c)):(t.name=e.slice(o,r),t.base=e.slice(o,c),t.ext=e.slice(r,c)),t.dir=o>0&&o!==n?e.slice(0,o-1):t.root,t},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...e){let t="",n=!1;for(let i=e.length-1;i>=-1&&!n;i--){let r;u(r=i>=0?e[i]:s.cwd(),"path"),0!==r.length&&(t=r+"/"+t,n=r.charCodeAt(0)===c)}return t=m(t,!n,"/",f),n?t.length>0?"/"+t:"/":t.length>0?t:"."},normalize(e){if(u(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===c,s=e.charCodeAt(e.length-1)===c;return 0!==(e=m(e,!t,"/",f)).length||t||(e="."),e.length>0&&s&&(e+="/"),t?"/"+e:e},isAbsolute:e=>(u(e,"path"),e.length>0&&e.charCodeAt(0)===c),join(...e){if(0===e.length)return"."
;let s;for(let t=0;t<e.length;++t){const e=arguments[t];u(e,"path"),e.length>0&&(void 0===s?s=e:s+="/"+e)}return void 0===s?".":t.posix.normalize(s)},relative(e,s){if(u(e,"from"),u(s,"to"),e===s)return"";if((e=t.posix.resolve(e))===(s=t.posix.resolve(s)))return"";let n=1;for(;n<e.length&&e.charCodeAt(n)===c;++n);const i=e.length,r=i-n;let o=1;for(;o<s.length&&s.charCodeAt(o)===c;++o);const a=s.length-o,h=r<a?r:a;let l=-1,d=0;for(;d<=h;++d){if(d===h){if(a>h){if(s.charCodeAt(o+d)===c)return s.slice(o+d+1);if(0===d)return s.slice(o+d)}else r>h&&(e.charCodeAt(n+d)===c?l=d:0===d&&(l=0));break}const t=e.charCodeAt(n+d);if(t!==s.charCodeAt(o+d))break;t===c&&(l=d)}let f="";for(d=n+l+1;d<=i;++d)d!==i&&e.charCodeAt(d)!==c||(0===f.length?f+="..":f+="/..");return f.length>0?f+s.slice(o+l):(o+=l,s.charCodeAt(o)===c&&++o,s.slice(o))},toNamespacedPath:e=>e,dirname(e){if(u(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===c;let s=-1,n=!0;for(let t=e.length-1;t>=1;--t)if(e.charCodeAt(t)===c){if(!n){s=t;break}
}else n=!1;return-1===s?t?"/":".":t&&1===s?"//":e.slice(0,s)},basename(e,t){void 0!==t&&u(t,"ext"),u(e,"path");let s,n=0,i=-1,r=!0;if(void 0!==t&&t.length>0&&t.length<=e.length){if(t.length===e.length&&t===e)return"";let o=t.length-1,a=-1;for(s=e.length-1;s>=0;--s){const h=e.charCodeAt(s);if(h===c){if(!r){n=s+1;break}}else-1===a&&(r=!1,a=s+1),o>=0&&(h===t.charCodeAt(o)?-1==--o&&(i=s):(o=-1,i=a))}return n===i?i=a:-1===i&&(i=e.length),e.slice(n,i)}for(s=e.length-1;s>=0;--s)if(e.charCodeAt(s)===c){if(!r){n=s+1;break}}else-1===i&&(r=!1,i=s+1);return-1===i?"":e.slice(n,i)},extname(e){u(e,"path");let t=-1,s=0,n=-1,i=!0,r=0;for(let o=e.length-1;o>=0;--o){const h=e.charCodeAt(o);if(h!==c)-1===n&&(i=!1,n=o+1),h===a?-1===t?t=o:1!==r&&(r=1):-1!==t&&(r=-1);else if(!i){s=o+1;break}}return-1===t||-1===n||0===r||1===r&&t===n-1&&t===s+1?"":e.slice(t,n)},format(e){if(null===e||"object"!=typeof e)throw new l("pathObject","Object",e);return g("/",e)},parse(e){u(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""}
;if(0===e.length)return t;const s=e.charCodeAt(0)===c;let n;s?(t.root="/",n=1):n=0;let i=-1,r=0,o=-1,h=!0,l=e.length-1,d=0;for(;l>=n;--l){const t=e.charCodeAt(l);if(t!==c)-1===o&&(h=!1,o=l+1),t===a?-1===i?i=l:1!==d&&(d=1):-1!==i&&(d=-1);else if(!h){r=l+1;break}}return-1===i||-1===o||0===d||1===d&&i===o-1&&i===r+1?-1!==o&&(t.base=t.name=0===r&&s?e.slice(1,o):e.slice(r,o)):(0===r&&s?(t.name=e.slice(1,i),t.base=e.slice(1,o)):(t.name=e.slice(r,i),t.base=e.slice(r,o)),t.ext=e.slice(i,o)),r>0?t.dir=e.slice(0,r-1):s&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize="win32"===s.platform?t.win32.normalize:t.posix.normalize,t.isAbsolute="win32"===s.platform?t.win32.isAbsolute:t.posix.isAbsolute,t.join="win32"===s.platform?t.win32.join:t.posix.join,t.resolve="win32"===s.platform?t.win32.resolve:t.posix.resolve,t.relative="win32"===s.platform?t.win32.relative:t.posix.relative,
t.dirname="win32"===s.platform?t.win32.dirname:t.posix.dirname,t.basename="win32"===s.platform?t.win32.basename:t.posix.basename,t.extname="win32"===s.platform?t.win32.extname:t.posix.extname,t.format="win32"===s.platform?t.win32.format:t.posix.format,t.parse="win32"===s.platform?t.win32.parse:t.posix.parse,t.toNamespacedPath="win32"===s.platform?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep="win32"===s.platform?t.win32.sep:t.posix.sep,t.delimiter="win32"===s.platform?t.win32.delimiter:t.posix.delimiter})),define(e[14],t([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0});class s{constructor(e){this._value=e}asHex(){return this._value}}class n extends s{constructor(){
super([n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),"-",n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),"-","4",n._randomHex(),n._randomHex(),n._randomHex(),"-",n._oneOf(n._timeHighBits),n._randomHex(),n._randomHex(),n._randomHex(),"-",n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex(),n._randomHex()].join(""))}static _oneOf(e){return e[Math.floor(e.length*Math.random())]}static _randomHex(){return n._oneOf(n._chars)}}function i(){return new n}n._chars=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"],n._timeHighBits=["8","9","a","b"],t.v4=i;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function o(e){return r.test(e)}t.isUUID=o,t.parse=function(e){if(!o(e))throw new Error("invalid uuid");return new s(e)},t.generateUuid=function(){return i().asHex()}})),
define(e[10],t([0,1,2,3,12,6,4,5]),(function(e,t,s,n,i,r,o,a){"use strict";var c,h;Object.defineProperty(t,"__esModule",{value:!0}),function(e){e[e.Promise=100]="Promise",e[e.PromiseCancel=101]="PromiseCancel",e[e.EventListen=102]="EventListen",e[e.EventDispose=103]="EventDispose"}(t.RequestType||(t.RequestType={})),function(e){e[e.Initialize=200]="Initialize",e[e.PromiseSuccess=201]="PromiseSuccess",e[e.PromiseError=202]="PromiseError",e[e.PromiseErrorObj=203]="PromiseErrorObj",e[e.EventFire=204]="EventFire"}(t.ResponseType||(t.ResponseType={})),function(e){e[e.Uninitialized=0]="Uninitialized",e[e.Idle=1]="Idle"}(c||(c={}));class l{constructor(e){this.buffer=e,this.pos=0}read(e){const t=this.buffer.slice(this.pos,this.pos+e);return this.pos+=t.byteLength,t}}class u{constructor(){this.buffers=[]}get buffer(){return a.VSBuffer.concat(this.buffers)}write(e){this.buffers.push(e)}}function d(e){const t=a.VSBuffer.alloc(4);return t.writeUInt32BE(e,0),t}function f(e){return e.read(4).readUInt32BE(0)}function p(e){
const t=a.VSBuffer.alloc(1);return t.writeUInt8(e,0),t}!function(e){e[e.Undefined=0]="Undefined",e[e.String=1]="String",e[e.Buffer=2]="Buffer",e[e.VSBuffer=3]="VSBuffer",e[e.Array=4]="Array",e[e.Object=5]="Object"}(h||(h={}));const m={Undefined:p(h.Undefined),String:p(h.String),Buffer:p(h.Buffer),VSBuffer:p(h.VSBuffer),Array:p(h.Array),Object:p(h.Object)},g="undefined"!=typeof Buffer;function _(e,t){if(void 0===t)e.write(m.Undefined);else if("string"==typeof t){const s=a.VSBuffer.fromString(t);e.write(m.String),e.write(d(s.byteLength)),e.write(s)}else if(g&&Buffer.isBuffer(t)){const s=a.VSBuffer.wrap(t);e.write(m.Buffer),e.write(d(s.byteLength)),e.write(s)}else if(t instanceof a.VSBuffer)e.write(m.VSBuffer),e.write(d(t.byteLength)),e.write(t);else if(Array.isArray(t)){e.write(m.Array),e.write(d(t.length));for(const s of t)_(e,s)}else{const s=a.VSBuffer.fromString(JSON.stringify(t));e.write(m.Object),e.write(d(s.byteLength)),e.write(s)}}function v(e){switch(e.read(1).readUInt8(0)){case h.Undefined:return
;case h.String:return e.read(f(e)).toString();case h.Buffer:return e.read(f(e)).buffer;case h.VSBuffer:return e.read(f(e));case h.Array:{const t=f(e),s=[];for(let n=0;n<t;n++)s.push(v(e));return s}case h.Object:return JSON.parse(e.read(f(e)).toString())}}class w{constructor(e,t,s=1e3){this.protocol=e,this.ctx=t,this.timeoutDelay=s,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(e=>this.onRawMessage(e)),this.sendResponse({type:200})}registerChannel(e,t){this.channels.set(e,t),setTimeout(()=>this.flushPendingRequests(e),0)}sendResponse(e){switch(e.type){case 200:return this.send([e.type]);case 201:case 202:case 204:case 203:return this.send([e.type,e.id],e.data)}}send(e,t){const s=new u;_(s,e),_(s,t),this.sendBuffer(s.buffer)}sendBuffer(e){try{this.protocol.send(e)}catch(e){}}onRawMessage(e){const t=new l(e),s=v(t),n=v(t),i=s[0];switch(i){case 100:return this.onPromise({type:i,id:s[1],channelName:s[2],name:s[3],arg:n});case 102:
return this.onEventListen({type:i,id:s[1],channelName:s[2],name:s[3],arg:n});case 101:case 103:return this.disposeActiveRequest({type:i,id:s[1]})}}onPromise(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const s=new r.CancellationTokenSource;let i;try{i=t.call(this.ctx,e.name,e.arg,s.token)}catch(e){i=Promise.reject(e)}const o=e.id;i.then(t=>{this.sendResponse({id:o,data:t,type:201}),this.activeRequests.delete(e.id)},t=>{t instanceof Error?this.sendResponse({id:o,data:{message:t.message,name:t.name,stack:t.stack?t.stack.split?t.stack.split("\n"):t.stack:void 0},type:202}):this.sendResponse({id:o,data:t,type:203}),this.activeRequests.delete(e.id)});const a=n.toDisposable(()=>s.cancel());this.activeRequests.set(e.id,a)}onEventListen(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const s=e.id,n=t.listen(this.ctx,e.name,e.arg)(e=>this.sendResponse({id:s,data:e,type:204}));this.activeRequests.set(e.id,n)}
disposeActiveRequest(e){const t=this.activeRequests.get(e.id);t&&(t.dispose(),this.activeRequests.delete(e.id))}collectPendingRequest(e){let t=this.pendingRequests.get(e.channelName);t||(t=[],this.pendingRequests.set(e.channelName,t));const s=setTimeout(()=>{console.error(`Unknown channel: ${e.channelName}`),100===e.type&&this.sendResponse({id:e.id,data:{name:"Unknown channel",message:`Channel name '${e.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);t.push({request:e,timeoutTimer:s})}flushPendingRequests(e){const t=this.pendingRequests.get(e);if(t){for(const e of t)switch(clearTimeout(e.timeoutTimer),e.request.type){case 100:this.onPromise(e.request);break;case 102:this.onEventListen(e.request)}this.pendingRequests.delete(e)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelServer=w;class k{constructor(e){this.protocol=e,
this.state=c.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new s.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(e=>this.onBuffer(e))}getChannel(e){const t=this;return{call:(s,n,i)=>t.requestPromise(e,s,n,i),listen:(s,n)=>t.requestEvent(e,s,n)}}requestPromise(e,t,s,a=r.CancellationToken.None){const c=this.lastRequestId++,h={id:c,type:100,channelName:e,name:t,arg:s};if(a.isCancellationRequested)return Promise.reject(o.canceled());let l;return new Promise((e,t)=>{if(a.isCancellationRequested)return t(o.canceled());let s=i.createCancelablePromise(e=>this.whenInitialized());s.then(()=>{s=null;this.handlers.set(c,s=>{switch(s.type){case 201:this.handlers.delete(c),e(s.data);break;case 202:this.handlers.delete(c);const n=new Error(s.data.message);n.stack=s.data.stack,n.name=s.data.name,t(n);break;case 203:this.handlers.delete(c),t(s.data)}}),this.sendRequest(h)});const r=()=>{s?(s.cancel(),
s=null):this.sendRequest({id:c,type:101}),t(o.canceled())},u=a.onCancellationRequested(r);l=n.combinedDisposable(n.toDisposable(r),u),this.activeRequests.add(l)}).finally(()=>this.activeRequests.delete(l))}requestEvent(e,t,n){const r=this.lastRequestId++,o={id:r,type:102,channelName:e,name:t,arg:n};let a=null;const c=new s.Emitter({onFirstListenerAdd:()=>{(a=i.createCancelablePromise(e=>this.whenInitialized())).then(()=>{a=null,this.activeRequests.add(c),this.sendRequest(o)})},onLastListenerRemove:()=>{a?(a.cancel(),a=null):(this.activeRequests.delete(c),this.sendRequest({id:r,type:103}))}});return this.handlers.set(r,e=>c.fire(e.data)),c.event}sendRequest(e){switch(e.type){case 100:case 102:return this.send([e.type,e.id,e.channelName,e.name],e.arg);case 101:case 103:return this.send([e.type,e.id])}}send(e,t){const s=new u;_(s,e),_(s,t),this.sendBuffer(s.buffer)}sendBuffer(e){try{this.protocol.send(e)}catch(e){}}onBuffer(e){const t=new l(e),s=v(t),n=v(t);switch(s[0]){case 200:return this.onResponse({type:s[0]
});case 201:case 202:case 204:case 203:return this.onResponse({type:s[0],id:s[1],data:n})}}onResponse(e){if(200===e.type)return this.state=c.Idle,void this._onDidInitialize.fire();const t=this.handlers.get(e.id);t&&t(e)}whenInitialized(){return this.state===c.Idle?Promise.resolve():s.Event.toPromise(this.onDidInitialize)}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelClient=k;t.IPCServer=class{constructor(e){this.channels=new Map,this._connections=new Set,this._onDidChangeConnections=new s.Emitter,this.onDidChangeConnections=this._onDidChangeConnections.event,e(({protocol:e,onDidClientDisconnect:t})=>{s.Event.once(e.onMessage)(s=>{const n=v(new l(s)),i=new w(e,n),r=new k(e);this.channels.forEach((e,t)=>i.registerChannel(t,e));const o={channelServer:i,channelClient:r,ctx:n};this._connections.add(o),this._onDidChangeConnections.fire(o),t(()=>{i.dispose(),r.dispose(),
this._connections.delete(o)})})})}get connections(){const e=[];return this._connections.forEach(t=>e.push(t)),e}getChannel(e,t){const s=this;return{call:(n,i,r)=>b(t.routeCall(s,n,i).then(t=>t.channelClient.getChannel(e))).call(n,i,r),listen:(n,i)=>b(t.routeEvent(s,n,i).then(t=>t.channelClient.getChannel(e))).listen(n,i)}}registerChannel(e,t){this.channels.set(e,t),this._connections.forEach(s=>{s.channelServer.registerChannel(e,t)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidChangeConnections.dispose()}};function b(e){return{call:(t,s,n)=>e.then(e=>e.call(t,s,n)),listen(t,n){const i=new s.Relay;return e.then(e=>i.input=e.listen(t,n)),i.event}}}t.IPCClient=class{constructor(e,t){const s=new u;_(s,t),e.send(s.buffer),this.channelClient=new k(e),this.channelServer=new w(e,t)}getChannel(e){return this.channelClient.getChannel(e)}registerChannel(e,t){this.channelServer.registerChannel(e,t)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}},t.getDelayedChannel=b,
t.getNextTickChannel=function(e){let t=!1;return{call:(s,n,r)=>t?e.call(s,n,r):i.timeout(0).then(()=>t=!0).then(()=>e.call(s,n,r)),listen(n,r){if(t)return e.listen(n,r);const o=new s.Relay;return i.timeout(0).then(()=>t=!0).then(()=>o.input=e.listen(n,r)),o.event}}};t.StaticRouter=class{constructor(e){this.fn=e}routeCall(e){return this.route(e)}routeEvent(e){return this.route(e)}async route(e){for(const t of e.connections)if(await Promise.resolve(this.fn(t.ctx)))return Promise.resolve(t);return await s.Event.toPromise(e.onDidChangeConnections),await this.route(e)}}})),define(e[16],t([0,1,2,10,3,5,8,9]),(function(e,t,s,n,i,r,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0});let c=null;function h(){return c||(c=r.VSBuffer.alloc(0)),c}class l{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(e){this._chunks.push(e),this._totalLength+=e.byteLength}read(e){return this._read(e,!0)}peek(e){return this._read(e,!1)}_read(e,t){if(0===e)return h()
;if(e>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===e){const s=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=e),s}if(this._chunks[0].byteLength>e){const s=this._chunks[0].slice(0,e);return t&&(this._chunks[0]=this._chunks[0].slice(e),this._totalLength-=e),s}let s=r.VSBuffer.alloc(e),n=0,i=0;for(;e>0;){const r=this._chunks[i];if(r.byteLength>e){const o=r.slice(0,e);s.set(o,n),n+=e,t&&(this._chunks[i]=r.slice(e),this._totalLength-=e),e-=e}else s.set(r,n),n+=r.byteLength,t?(this._chunks.shift(),this._totalLength-=r.byteLength):i++,e-=r.byteLength}return s}}var u;t.ChunkStream=l,function(e){e[e.None=0]="None",e[e.Regular=1]="Regular",e[e.Control=2]="Control",e[e.Ack=3]="Ack",e[e.KeepAlive=4]="KeepAlive",e[e.Disconnect=5]="Disconnect"}(u||(u={})),function(e){e[e.HeaderLength=13]="HeaderLength",e[e.AcknowledgeTime=2e3]="AcknowledgeTime",e[e.AcknowledgeTimeoutTime=1e4]="AcknowledgeTimeoutTime",e[e.KeepAliveTime=5e3]="KeepAliveTime",
e[e.KeepAliveTimeoutTime=1e4]="KeepAliveTimeoutTime",e[e.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",e[e.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"}(t.ProtocolConstants||(t.ProtocolConstants={}));class d{constructor(e,t,s,n){this.type=e,this.id=t,this.ack=s,this.data=n,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends i.Disposable{constructor(e){super(),this._onMessage=this._register(new s.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=e,this._isDisposed=!1,this._incomingData=new l,this._register(this._socket.onData(e=>this.acceptChunk(e))),this.lastReadTime=Date.now()}acceptChunk(e){if(e&&0!==e.byteLength)for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;){const e=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=e.readUInt32BE(9),
this._state.messageType=e.readUInt8(0),this._state.id=e.readUInt32BE(1),this._state.ack=e.readUInt32BE(5);else{const t=this._state.messageType,s=this._state.id,n=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(t,s,n,e)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(e){this._isDisposed=!1,this._socket=e,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){this.flush(),this._isDisposed=!0}flush(){this._writeNow()}write(e){if(this._isDisposed)return console.warn("Cannot write message in a disposed ProtocolWriter"),void console.warn(e);e.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=r.VSBuffer.alloc(13);t.writeUInt8(e.type,0),t.writeUInt32BE(e.id,1),t.writeUInt32BE(e.ack,5),t.writeUInt32BE(e.data.byteLength,9),this._writeSoon(t,e.data)}_bufferAdd(e,t){
const s=0===this._totalLength;return this._data.push(e,t),this._totalLength+=e.byteLength+t.byteLength,s}_bufferTake(){const e=r.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,e}_writeSoon(e,t){this._bufferAdd(e,t)&&o.setImmediate(()=>{this._writeNow()})}_writeNow(){0!==this._totalLength&&this._socket.write(this._bufferTake())}}class m extends i.Disposable{constructor(e){super(),this._onMessage=new s.Emitter,this.onMessage=this._onMessage.event,this._onClose=new s.Emitter,this.onClose=this._onClose.event,this._socket=e,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(e=>{1===e.type&&this._onMessage.fire(e.data)})),this._register(this._socket.onClose(()=>this._onClose.fire()))}getSocket(){return this._socket}sendDisconnect(){}send(e){this._socketWriter.write(new d(1,0,0,e))}}t.Protocol=m;class g extends n.IPCClient{constructor(e,t){super(e,t),this.protocol=e}
static fromSocket(e,t){return new g(new m(e),t)}get onClose(){return this.protocol.onClose}dispose(){super.dispose();const e=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),e.end()}}t.Client=g;class _{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new s.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,a.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(e){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(e):this._emitter.fire(e):this._bufferedMessages.push(e)}flushBuffer(){this._bufferedMessages=[]}}t.BufferedEmitter=_;class v{constructor(e){this.data=e,this.next=null}}class w{constructor(){
this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let e=[],t=0,s=this._first;for(;s;)e[t++]=s.data,s=s.next;return e}pop(){if(this._first)return this._first===this._last?(this._first=null,void(this._last=null)):void(this._first=this._first.next)}push(e){const t=new v(e);if(!this._first)return this._first=t,void(this._last=t);this._last.next=t,this._last=t}}t.PersistentProtocol=class{constructor(e,t=null){this._onControlMessage=new _,this.onControlMessage=this._onControlMessage.event,this._onMessage=new _,this.onMessage=this._onMessage.event,this._onClose=new _,this.onClose=this._onClose.event,this._onSocketClose=new _,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new _,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new w,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,
this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._socketDisposables=[],this._socket=e,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),t&&this._socketReader.acceptChunk(t),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),
this._incomingKeepAliveTimeout=null),this._socketDisposables=i.dispose(this._socketDisposables)}sendDisconnect(){const e=new d(5,0,0,h());this._socketWriter.write(e),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const e=Date.now()-this._socketWriter.lastWriteTime;if(e>=5e3){const e=new d(4,0,0,h());return this._socketWriter.write(e),void this._sendKeepAliveCheck()}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-e+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const e=Date.now()-this._socketReader.lastReadTime;e>=1e4?this._onSocketTimeout.fire(void 0):this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},1e4-e+5)}getSocket(){return this._socket}beginAcceptReconnection(e,t){this._isReconnecting=!0,this._socketDisposables=i.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),
this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._socket=e,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1;const e=this._outgoingUnackMsg.toArray();for(let t=0,s=e.length;t<s;t++)this._socketWriter.write(e[t]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onClose.fire()}_receiveMessage(e){if(e.ack>this._outgoingAckId)for(this._outgoingAckId=e.ack;;){const t=this._outgoingUnackMsg.peek();if(!(t&&t.id<=e.ack))break;this._outgoingUnackMsg.pop()}
1===e.type?e.id>this._incomingMsgId&&(e.id!==this._incomingMsgId+1&&console.error(`PROTOCOL CORRUPTION, LAST SAW MSG ${this._incomingMsgId} AND HAVE NOW RECEIVED MSG ${e.id}`),this._incomingMsgId=e.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(e.data)):2===e.type?this._onControlMessage.fire(e.data):5===e.type&&this._onClose.fire()}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(e){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const s=new d(1,t,this._incomingAckId,e);this._outgoingUnackMsg.push(s),this._isReconnecting||(this._socketWriter.write(s),this._recvAckCheck())}sendControl(e){const t=new d(2,0,0,e);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId)return;if(this._incomingAckTimeout)return;const e=Date.now()-this._incomingMsgLastTime;e>=2e3?this._sendAck():this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()
},2e3-e+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId)return;if(this._outgoingAckTimeout)return;const e=this._outgoingUnackMsg.peek(),t=Date.now()-e.writtenTime;t>=1e4?this._onSocketTimeout.fire(void 0):this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},1e4-t+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const e=new d(3,0,this._incomingAckId,h());this._socketWriter.write(e)}}})),define(e[17],t([0,1,18,2,10,13,19,14,3,5,16]),(function(e,t,s,n,i,r,o,a,c,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0});class u{constructor(e){this.socket=e}dispose(){this.socket.destroy()}onData(e){const t=t=>e(h.VSBuffer.wrap(t));return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(e){return this.socket.on("close",e),{dispose:()=>this.socket.off("close",e)}}onEnd(e){return this.socket.on("end",e),{dispose:()=>this.socket.off("end",e)}}write(e){
this.socket.destroyed||this.socket.write(e.buffer)}end(){this.socket.end()}}var d,f;t.NodeSocket=u,function(e){e[e.MinHeaderByteSize=2]="MinHeaderByteSize"}(d||(d={})),function(e){e[e.PeekHeader=1]="PeekHeader",e[e.ReadHeader=2]="ReadHeader",e[e.ReadBody=3]="ReadBody",e[e.Fin=4]="Fin"}(f||(f={}));function p(e,t){if(0===t)return;let s=e.byteLength>>>2;for(let n=0;n<s;n++){const s=e.readUInt32BE(4*n);e.writeUInt32BE(s^t,4*n)}let n=4*s,i=e.byteLength-n;const r=t>>>24&255,o=t>>>16&255,a=t>>>8&255;i>=1&&e.writeUInt8(e.readUInt8(n)^r,n),i>=2&&e.writeUInt8(e.readUInt8(n+1)^o,n+1),i>=3&&e.writeUInt8(e.readUInt8(n+2)^a,n+2)}t.WebSocketNodeSocket=class extends c.Disposable{constructor(e){super(),this._onData=this._register(new n.Emitter),this._state={state:1,readLen:2,mask:0},this.socket=e,this._incomingData=new l.ChunkStream,this._register(this.socket.onData(e=>this._acceptChunk(e)))}dispose(){this.socket.dispose()}onData(e){return this._onData.event(e)}onClose(e){return this.socket.onClose(e)}onEnd(e){
return this.socket.onEnd(e)}write(e){let t=2;e.byteLength<126?t+=0:e.byteLength<65536?t+=2:t+=8;const s=h.VSBuffer.alloc(t);if(s.writeUInt8(130,0),e.byteLength<126)s.writeUInt8(e.byteLength,1);else if(e.byteLength<65536){s.writeUInt8(126,1);let t=1;s.writeUInt8(e.byteLength>>>8&255,++t),s.writeUInt8(e.byteLength>>>0&255,++t)}else{s.writeUInt8(127,1);let t=1;s.writeUInt8(0,++t),s.writeUInt8(0,++t),s.writeUInt8(0,++t),s.writeUInt8(0,++t),s.writeUInt8(e.byteLength>>>24&255,++t),s.writeUInt8(e.byteLength>>>16&255,++t),s.writeUInt8(e.byteLength>>>8&255,++t),s.writeUInt8(e.byteLength>>>0&255,++t)}this.socket.write(h.VSBuffer.concat([s,e]))}end(){this.socket.end()}_acceptChunk(e){if(0!==e.byteLength)for(this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;)if(1===this._state.state){const e=this._incomingData.peek(this._state.readLen).readUInt8(1),t=(128&e)>>>7,s=127&e;this._state.state=2,this._state.readLen=2+(t?4:0)+(126===s?2:0)+(127===s?8:0),this._state.mask=0
}else if(2===this._state.state){const e=this._incomingData.read(this._state.readLen),t=e.readUInt8(1),s=(128&t)>>>7;let n=127&t,i=1;126===n?n=256*e.readUInt8(++i)+e.readUInt8(++i):127===n&&(n=0*e.readUInt8(++i)+0*e.readUInt8(++i)+0*e.readUInt8(++i)+0*e.readUInt8(++i)+e.readUInt8(++i)*2**24+65536*e.readUInt8(++i)+256*e.readUInt8(++i)+e.readUInt8(++i));let r=0;s&&(r=e.readUInt8(++i)*2**24+65536*e.readUInt8(++i)+256*e.readUInt8(++i)+e.readUInt8(++i)),this._state.state=3,this._state.readLen=n,this._state.mask=r}else if(3===this._state.state){const e=this._incomingData.read(this._state.readLen);p(e,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._onData.fire(e)}}},t.generateRandomPipeName=function(){const e=a.generateUuid();return"win32"===process.platform?`\\\\.\\pipe\\vscode-ipc-${e}-sock`:r.join(o.tmpdir(),`vscode-ipc-${e}.sock`)};class m extends i.IPCServer{constructor(e){super(m.toClientConnectionEvent(e)),this.server=e}static toClientConnectionEvent(e){
const t=n.Event.fromNodeEventEmitter(e,"connection");return n.Event.map(t,e=>({protocol:new l.Protocol(new u(e)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(e,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}t.Server=m,t.serve=function(e){return new Promise((t,n)=>{const i=s.createServer();i.on("error",n),i.listen(e,()=>{i.removeListener("error",n),t(new m(i))})})},t.connect=function(e,t){return new Promise((n,i)=>{const r=s.createConnection(e,()=>{r.removeListener("error",i),n(l.Client.fromSocket(new u(r),t))});r.once("error",i)})}})),define(e[20],t([0,1,17]),(function(e,t,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0});t.DriverChannel=class{constructor(e){this.driver=e}listen(e,t){throw new Error("No event found")}call(e,t,s){switch(t){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(s);case"reloadWindow":return this.driver.reloadWindow(s);case"exitApplication":
return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(s[0],s[1]);case"click":return this.driver.click(s[0],s[1],s[2],s[3]);case"doubleClick":return this.driver.doubleClick(s[0],s[1]);case"setValue":return this.driver.setValue(s[0],s[1],s[2]);case"getTitle":return this.driver.getTitle(s[0]);case"isActiveElement":return this.driver.isActiveElement(s[0],s[1]);case"getElements":return this.driver.getElements(s[0],s[1],s[2]);case"getElementXY":return this.driver.getElementXY(s[0],s[1],s[2]);case"typeInEditor":return this.driver.typeInEditor(s[0],s[1],s[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(s[0],s[1]);case"writeInTerminal":return this.driver.writeInTerminal(s[0],s[1],s[2])}throw new Error(`Call not found: ${t}`)}};class n{constructor(e){this.channel=e}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(e){return this.channel.call("capturePage",e)}reloadWindow(e){return this.channel.call("reloadWindow",e)}exitApplication(){
return this.channel.call("exitApplication")}dispatchKeybinding(e,t){return this.channel.call("dispatchKeybinding",[e,t])}click(e,t,s,n){return this.channel.call("click",[e,t,s,n])}doubleClick(e,t){return this.channel.call("doubleClick",[e,t])}setValue(e,t,s){return this.channel.call("setValue",[e,t,s])}getTitle(e){return this.channel.call("getTitle",[e])}isActiveElement(e,t){return this.channel.call("isActiveElement",[e,t])}getElements(e,t,s){return this.channel.call("getElements",[e,t,s])}getElementXY(e,t,s,n){return this.channel.call("getElementXY",[e,t,s,n])}typeInEditor(e,t,s){return this.channel.call("typeInEditor",[e,t,s])}getTerminalBuffer(e,t){return this.channel.call("getTerminalBuffer",[e,t])}writeInTerminal(e,t,s){return this.channel.call("writeInTerminal",[e,t,s])}}t.DriverChannelClient=n;t.WindowDriverRegistryChannel=class{constructor(e){this.registry=e}listen(e,t){throw new Error(`Event not found: ${t}`)}call(e,t,s){switch(t){case"registerWindowDriver":
return this.registry.registerWindowDriver(s);case"reloadWindowDriver":return this.registry.reloadWindowDriver(s)}throw new Error(`Call not found: ${t}`)}};t.WindowDriverRegistryChannelClient=class{constructor(e){this.channel=e}registerWindowDriver(e){return this.channel.call("registerWindowDriver",e)}reloadWindowDriver(e){return this.channel.call("reloadWindowDriver",e)}};t.WindowDriverChannel=class{constructor(e){this.driver=e}listen(e,t){throw new Error(`No event found: ${t}`)}call(e,t,s){switch(t){case"click":return this.driver.click(s[0],s[1],s[2]);case"doubleClick":return this.driver.doubleClick(s);case"setValue":return this.driver.setValue(s[0],s[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(s);case"getElements":return this.driver.getElements(s[0],s[1]);case"getElementXY":return this.driver.getElementXY(s[0],s[1],s[2]);case"typeInEditor":return this.driver.typeInEditor(s[0],s[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(s)
;case"writeInTerminal":return this.driver.writeInTerminal(s[0],s[1])}throw new Error(`Call not found: ${t}`)}};t.WindowDriverChannelClient=class{constructor(e){this.channel=e}click(e,t,s){return this.channel.call("click",[e,t,s])}doubleClick(e){return this.channel.call("doubleClick",e)}setValue(e,t){return this.channel.call("setValue",[e,t])}getTitle(){return this.channel.call("getTitle")}isActiveElement(e){return this.channel.call("isActiveElement",e)}getElements(e,t){return this.channel.call("getElements",[e,t])}getElementXY(e,t,s){return this.channel.call("getElementXY",[e,t,s])}typeInEditor(e,t){return this.channel.call("typeInEditor",[e,t])}getTerminalBuffer(e){return this.channel.call("getTerminalBuffer",e)}writeInTerminal(e,t){return this.channel.call("writeInTerminal",[e,t])}},t.connect=async function(e){const t=await s.connect(e,"driverClient"),i=t.getChannel("driver");return{client:t,driver:new n(i)}}}))}).call(this);
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6ab598523be7a800d7f3eb4d92d7ab9a66069390/core/vs/platform/driver/node/driver.js.map
